SystemOrganization addCategory: #'Caitlin-World'!

Object subclass: #CWPerson
	instanceVariableNames: 'room seen name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWPerson class methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:48'!
name: aName
	^self name: aName in: nil! !

!CWPerson class methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:25'!
name: aName in: aRoom
	^super new name: aName; room: aRoom; yourself! !

!CWPerson class methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:51'!
new
	^self error: 'Use name: or name: in: instead'.! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:06'!
back
	self go: room lastRoom
! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:10'!
describe
	Transcript show: 'I am ' , name , ' and I am '.
	room ifNotNil: [Transcript show: 'in ' , room name]
		ifNil: [Transcript show: 'nowhere'].
	Transcript cr! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:05'!
forward
	self go: room nextRoom 
! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:05'!
go: aRoom
	aRoom
		ifNil: [
			Transcript show: 'You can''t go that way!!';cr.	
			self status. 
		] ifNotNil: [ 
			room := aRoom.
			(seen includes: room)
				ifTrue: [ self status. ]
				ifFalse: [ self look. ]
		].
! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:51'!
initialize
	seen := Set new.! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/5/2006 23:53'!
look
	room 
		ifNil: [Transcript show: 'You can''t see anything.  Are you lost?']
		ifNotNil: [
			Transcript show: room describe.
			seen add: room.
		].

	Transcript cr.! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/6/2006 00:10'!
name
	^name! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/6/2006 00:10'!
name: anObject 
	name := anObject! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:49'!
room
	^room! !

!CWPerson methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:49'!
room: anObject
	room := anObject! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:26'!
status
	"I show the current status of the person"
	Transcript show: 'In ', room name; cr.! !

Object subclass: #CWRoom
	instanceVariableNames: 'id description nextRoom lastRoom name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWRoom methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:11'!
describe
	| cr |
	cr := String cr.
	^'=== ' , name , ' ===' , cr , description , cr , '---' , cr 
		, (lastRoom ifNotNil: ['Behind you is ' , lastRoom name , '. ']
				ifNil: ['']) 
			, (nextRoom ifNotNil: ['The next room is ' , nextRoom name]
					ifNil: ['You can go no farther'])! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 20:01'!
description
	^description! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 20:01'!
description: anObject
	description := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/6/2006 00:12'!
id
	^id! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/6/2006 00:12'!
id: anObject
	id := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:41'!
lastRoom
	^lastRoom! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:41'!
lastRoom: anObject
	lastRoom := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/6/2006 00:09'!
name
	^name! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/6/2006 00:09'!
name: anObject 
	name := anObject! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:32'!
nextRoom
	^nextRoom! !

!CWRoom methodsFor: 'accessing' stamp: 'srh 11/5/2006 22:32'!
nextRoom: anObject
	nextRoom := anObject! !

Object subclass: #CWWorld
	instanceVariableNames: 'rooms firstRoom person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWWorld methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:40'!
addRoomMapping: aRoomId lastRoom: lastRoomId nextRoom: nextRoomId
	"I am a convenience method for mapping room exits to their destinations"

	(rooms at: aRoomId)
		lastRoom: (lastRoomId ifNil: [ nil ] ifNotNil: [ rooms at: lastRoomId ]);
		nextRoom: (nextRoomId ifNil: [ nil ] ifNotNil: [rooms at: nextRoomId ]).
	! !

!CWWorld methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:42'!
addRoom: aName description: aDescription! !

!CWWorld methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:44'!
addRoom: anId name: aName description: aDescription
	"Convenience message for adding rooms"

	^rooms  at: anId put: (CWRoom new
			id: anId;
			name: aName;
			description: aDescription;
			yourself)
! !

!CWWorld methodsFor: 'accessing' stamp: 'srh 11/5/2006 23:27'!
firstRoom
	^firstRoom! !

!CWWorld methodsFor: 'as yet unclassified' stamp: 'srh 11/6/2006 00:47'!
initialize
	rooms := Dictionary new.
	self	addRoom: 'loungeRoom' 
		name: 'The lounge room' 
		description: 'There''s a couch and a TV, and some video games'.

	self	addRoom: 'diningRoom' 
		name: 'The dining room'
		description: 'This is where we eat.  There''s a table and some chairs'.

	self addRoom: 'hallway' 
		name: 'The hallway'
		description: 'The hallway stretches in front of you, leading to the bedroom.'.

	self addRoom: 'bedroom'
		name: 'The bedroom'
		description: 'It''s a fairly normal bedroom, there''s a bed, a wardrobe and a bedside table.  The bed hasn''t been made'.

	self addRoomMapping: 'loungeRoom' lastRoom: nil nextRoom: 'diningRoom'.
	self addRoomMapping: 'diningRoom' lastRoom: nil nextRoom: 'hallway'.
	self addRoomMapping: 'hallway' lastRoom: nil nextRoom: 'bedroom'.
	self addRoomMapping: 'bedroom' lastRoom: 'hallway' nextRoom: nil.

	firstRoom := rooms at: 'loungeRoom'.
! !

!CWWorld methodsFor: 'accessing' stamp: 'srh 11/5/2006 23:45'!
person
	^person! !

!CWWorld methodsFor: 'accessing' stamp: 'srh 11/5/2006 23:46'!
person: aPerson
	person := aPerson.
	person room: firstRoom.! !
